// (c) 2005, Walter Heger, All rights reserved

//     This program cleans up the MostRecentlyUsed list of things that you did and places you visited.
// It is meant to give a user some privacy on a shared computer so that nosy people cannot easily
// find out where you have been surfing and at which images have you been looking!
// By giving this exe an input file (without specifing the .reg extension), you can see which files it removed from the registry, 
// and can optionally restore those at some later time by clicking on the file!

#region Using directives

using System;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
//using System.Runtime.Serialization.Formatters.Ascii;
using System.Text;
using System.Security.Permissions;
using Microsoft.Win32;
#endregion

namespace CleanUpMRU
{
    class Program : Object
    {
        //
        private void CleanWordPad(ref FileStream stream)
        {
            // Windows Media Player
            string REGISTRY_PATH = @"Software\Microsoft\Windows\CurrentVersion\Applets\Wordpad\Recent File List";

            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;

            MyKey = hklm.OpenSubKey(REGISTRY_PATH, true);
            if (null != MyKey)
            {
                if (null != stream)
                {
                    string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                    StreamWriter t = new StreamWriter(stream);
                    t.WriteLine(output);
                    t.Flush();
                }
                string[] strs = MyKey.GetValueNames();
                foreach (string s in strs)
                {
                    if (null != stream)
                    {
                        string output = ("\"" + s + "\"=string:" + MyKey.GetValue(s).ToString());
                        StreamWriter t = new StreamWriter(stream);
                        t.WriteLine(output);
                        t.Flush();
                    }
                    MyKey.SetValue( s, "");
                }
                MyKey.Close();
            }
        }
        private void CleanAdobeReader6(ref FileStream  stream)
        {
            // Windows Media Player
            string REGISTRY_PREFIX = @"Software\Adobe\Acrobat Reader\6.0\AVGeneral\cRecentFiles\c";
            
            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;
            for (int i = 1; i <= 4;i++ )
            {
                string si = i.ToString();

                string REGISTRY_PATH = REGISTRY_PREFIX + si;
                MyKey = hklm.OpenSubKey( REGISTRY_PATH, true);
                if (null != MyKey)
                {
                    string[] strs = MyKey.GetValueNames();
                    foreach (string s in strs)
                    {
                        if (null != stream)
                        {
                                string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                                StreamWriter t = new StreamWriter(stream);
                                t.WriteLine(output);
                                t.Flush();

                            if      ( RegistryValueKind.Binary == MyKey.GetValueKind(s))
                                output = ("\"" + s + "\"=hex:" + MyKey.GetValue(s).ToString());
                            else if ( RegistryValueKind.DWord==MyKey.GetValueKind(s))
                                output = ("\"" + s + "\"=dword:" + MyKey.GetValue(s).ToString());
                            else
                                output = ("\"" + s + "\"=string:" + MyKey.GetValue(s).ToString());
                            t.WriteLine( output);
                            t.Flush();
                        }
                        try {
                            MyKey.SetValue( s, 0, RegistryValueKind.Binary);
                        }
                        catch (ArgumentException)
                        {
                            Console.WriteLine("cannot modify key in reg");
                            MyKey.DeleteValue(s, false);
                            //MyKey.SetValue( s, 0, RegistryValueKind.Binary);
                        } 
                    }
                    MyKey.Close();
                }
            }
        }
        private void CleanIEMRU(ref FileStream   stream)
        {
            // Windows Media Player
            string REGISTRY_PATH = @"Software\Microsoft\Internet Explorer\TypedURLs";

            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;

            MyKey = hklm.OpenSubKey(REGISTRY_PATH, true);
            if (null != MyKey)
            {
                if (null != stream)
                {
                    string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                    StreamWriter t = new StreamWriter(stream);
                    t.WriteLine(output);
                    t.Flush();
                }
                string[] strs = MyKey.GetValueNames();
                foreach (string s in strs)
                {
                    if (null != stream)
                    {
                        string output = ("\"" + s + "\"=string:" + MyKey.GetValue(s).ToString());
                        StreamWriter t = new StreamWriter(stream);
                        t.WriteLine(output);
                        t.Flush();
                    }
                    MyKey.SetValue(s, "");
                }
                MyKey.Close();
            }
        }
        private void CleanYahoo(ref FileStream  stream)
        {
            string REGISTRY_PATH = @"Software\Yahoo\Companion\SearchHistory";

            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;

            MyKey = hklm.OpenSubKey(REGISTRY_PATH, true);
            if (null != MyKey)
            {
                if (null != stream)
                {
                    string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                    StreamWriter t = new StreamWriter(stream);
                    t.WriteLine(output);
                    t.Flush();
                }
                string[] strs = MyKey.GetValueNames();
                foreach (string s in strs)
                {
                    if (null != stream)
                    {
                        string output = ("\"" + s + "\"=string:"+ MyKey.GetValue(s).ToString());
                        StreamWriter t = new StreamWriter(stream);
                        t.WriteLine(output);
                        t.Flush();
                    }
                    MyKey.SetValue(s, "");
                }
                MyKey.Close();
            }
        }
        private void CleanMSMediaPlayerMRU(ref FileStream   stream)
        {
            // Windows Media Player
            string REGISTRY_PATH = @"Software\Microsoft\MediaPlayer\Player\RecentFileList";

            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;

            MyKey = hklm.OpenSubKey(REGISTRY_PATH, true);
            if (null != MyKey)
            {
                if (null != stream)
                {
                    string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                    StreamWriter t = new StreamWriter(stream);
                    t.WriteLine(output);
                    t.Flush();
                }
                string[] strs = MyKey.GetValueNames();
                foreach (string s in strs)
                {
                    if (null != stream)
                    {
                        string output = ("\"" + s + "\"=string:" + MyKey.GetValue(s).ToString());
                        StreamWriter t = new StreamWriter(stream);
                        t.WriteLine(output);
                        t.Flush();
                    }
                    MyKey.SetValue(s, "");
                }
                MyKey.Close();
            }        
        }
        private void CleanMSMediaPlayerURL(ref FileStream  stream)
        {
            // Windows Media Player
            string REGISTRY_PATH = @"Software\Microsoft\MediaPlayer\Player\RecentURLList";

            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;

            MyKey = hklm.OpenSubKey(REGISTRY_PATH, true);
            if (null != MyKey)
            {
                if (null != stream)
                {
                    string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                    StreamWriter t = new StreamWriter(stream);
                    t.WriteLine(output);
                    t.Flush();
                }
                string[] strs = MyKey.GetValueNames();
                foreach (string s in strs)
                {
                    if (null != stream)
                    {
                        string output = ("\"" + s + "\"=string:" + MyKey.GetValue(s).ToString());
                        StreamWriter t = new StreamWriter(stream);
                        t.WriteLine(output);
                        t.Flush();
                    }
                    MyKey.SetValue(s, "");
                }
                MyKey.Close();
            }
        }
        private void CleanMSMediaPlayerSet(ref FileStream  stream)
        {
            // Windows Media Player
            string REGISTRY_PATH = @"Software\Microsoft\MediaPlayer\Player\Settings";

            RegistryKey hklm = Registry.CurrentUser;
            RegistryKey MyKey;

            MyKey = hklm.OpenSubKey(REGISTRY_PATH, true);
            if (null != MyKey)
            {
                if (null != stream)
                {
                    string output = ("[" + "HKEY_CURRENT_USER\\" + REGISTRY_PATH + "]");
                    StreamWriter t = new StreamWriter(stream);
                    t.WriteLine(output);
                    t.Flush();
                }
                MyKey.SetValue("OpenDir", @"C:\");
                MyKey.SetValue( "SaveAsDir", @"C:\");

                MyKey.Close();
            }
        }
        public void CleanAll(ref FileStream stream)
        {
            CleanWordPad      ( ref stream);
            CleanAdobeReader6(ref stream);
            CleanIEMRU(ref stream);
            CleanYahoo(ref stream);
            CleanMSMediaPlayerMRU(ref stream);
            CleanMSMediaPlayerURL(ref stream);
            CleanMSMediaPlayerSet(ref stream);
        }

        static void Main(string[] args)
        {
            FileStream stream =null ;
            if ( 0 < args.GetLength(0)){
                string filename = args[0] + ".reg";
                Console.WriteLine("saving registry entries to:"+ filename);
                stream = File.Open( filename, FileMode.Create);
                string output = "Windows Registry Editor Version 5.00\n";
                StreamWriter t = new StreamWriter( stream);
                t.WriteLine( output);
                t.Flush();
            }

            // clean out the registry of visited locations!
            Program rp = new Program();
            rp.CleanAll( ref stream);
            //Console.WriteLine("waiting for your prompt!");
            //Console.ReadLine();
            // Real Player
            if (null != stream)
            {
                t.Flush();
                stream.Close();
            }
        }//main
    }//prog
}//namespace
